diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index 0e2e77a25..da9386924 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -25,8 +25,8 @@ public class BlockModelDoor<T extends BlockLogicDoor> extends BlockModelStandard
         AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
         TilePos queryPos = new TilePos();
 
-        boolean aboveIsDoor = Block.hasLogicClass(worldSource.getBlock(tilePos.up(queryPos)), BlockLogicDoor.class);
-        boolean belowIsDoor = Block.hasLogicClass(worldSource.getBlock(tilePos.down(queryPos)), BlockLogicDoor.class);
+        boolean aboveIsDoor = Block.hasLogicClass(worldSource.getBlockType(tilePos.up(queryPos)), BlockLogicDoor.class);
+        boolean belowIsDoor = Block.hasLogicClass(worldSource.getBlockType(tilePos.down(queryPos)), BlockLogicDoor.class);
 
         int meta = worldSource.getBlockData(tilePos);
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index be38e6e85..137361f9e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -81,13 +81,13 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
         double fenceBottommostMaxU = fenceBottommostTex.getSubIconU(onePix * 16);
         double fenceBottommostMaxV = fenceBottommostTex.getSubIconV(onePix * 16);
 
-        Block<?> blockAbove = worldSource.getBlock(tilePos.up(queryPos));
+        Block<?> blockAbove = worldSource.getBlockType(tilePos.up(queryPos));
         boolean connectUpNorth = blockAbove == this.block && thin.canConnectTo(worldSource, tilePos.up(queryPos), Side.NORTH);
         boolean connectUpSouth = blockAbove == this.block && thin.canConnectTo(worldSource, tilePos.up(queryPos), Side.SOUTH);
         boolean connectUpEast = blockAbove == this.block && thin.canConnectTo(worldSource, tilePos.up(queryPos), Side.EAST);
         boolean connectUpWest = blockAbove == this.block && thin.canConnectTo(worldSource, tilePos.up(queryPos), Side.WEST);
 
-        Block<?> blockBelow = worldSource.getBlock(tilePos.down(queryPos));
+        Block<?> blockBelow = worldSource.getBlockType(tilePos.down(queryPos));
         boolean connectDownNorth = blockBelow == this.block && thin.canConnectTo(worldSource, tilePos.down(queryPos), Side.NORTH);
         boolean connectDownSouth = blockBelow == this.block && thin.canConnectTo(worldSource, tilePos.down(queryPos), Side.SOUTH);
         boolean connectDownEast = blockBelow == this.block && thin.canConnectTo(worldSource, tilePos.down(queryPos), Side.EAST);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
index d37924c1d..7fd6d8f60 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
@@ -57,36 +57,36 @@ public class BlockModelGlass<T extends BlockLogic> extends BlockModelTransparent
             TilePos queryPos = new TilePos();
             switch (side) {
                 case SOUTH:
-                    u = source.getBlockId(tilePos.up(queryPos)) == this.block.id();
-                    d = source.getBlockId(tilePos.down(queryPos)) == this.block.id();
-                    l = source.getBlockId(tilePos.west(queryPos)) == this.block.id();
-                    r = source.getBlockId(tilePos.east(queryPos)) == this.block.id();
+                    u = source.getBlockType(tilePos.up(queryPos)) == this.block;
+                    d = source.getBlockType(tilePos.down(queryPos)) == this.block;
+                    l = source.getBlockType(tilePos.west(queryPos)) == this.block;
+                    r = source.getBlockType(tilePos.east(queryPos)) == this.block;
                     break;
                 case NORTH:
-                    u = source.getBlockId(tilePos.up(queryPos)) == this.block.id();
-                    d = source.getBlockId(tilePos.down(queryPos)) == this.block.id();
-                    l = source.getBlockId(tilePos.east(queryPos)) == this.block.id();
-                    r = source.getBlockId(tilePos.west(queryPos)) == this.block.id();
+                    u = source.getBlockType(tilePos.up(queryPos)) == this.block;
+                    d = source.getBlockType(tilePos.down(queryPos)) == this.block;
+                    l = source.getBlockType(tilePos.east(queryPos)) == this.block;
+                    r = source.getBlockType(tilePos.west(queryPos)) == this.block;
                     break;
                 case WEST:
-                    u = source.getBlockId(tilePos.up(queryPos)) == this.block.id();
-                    d = source.getBlockId(tilePos.down(queryPos)) == this.block.id();
-                    l = source.getBlockId(tilePos.north(queryPos)) == this.block.id();
-                    r = source.getBlockId(tilePos.south(queryPos)) == this.block.id();
+                    u = source.getBlockType(tilePos.up(queryPos)) == this.block;
+                    d = source.getBlockType(tilePos.down(queryPos)) == this.block;
+                    l = source.getBlockType(tilePos.north(queryPos)) == this.block;
+                    r = source.getBlockType(tilePos.south(queryPos)) == this.block;
                     break;
                 case EAST:
-                    u = source.getBlockId(tilePos.up(queryPos)) == this.block.id();
-                    d = source.getBlockId(tilePos.down(queryPos)) == this.block.id();
-                    l = source.getBlockId(tilePos.south(queryPos)) == this.block.id();
-                    r = source.getBlockId(tilePos.north(queryPos)) == this.block.id();
+                    u = source.getBlockType(tilePos.up(queryPos)) == this.block;
+                    d = source.getBlockType(tilePos.down(queryPos)) == this.block;
+                    l = source.getBlockType(tilePos.south(queryPos)) == this.block;
+                    r = source.getBlockType(tilePos.north(queryPos)) == this.block;
                     break;
                 case TOP:
                 case BOTTOM:
                 default:
-                    u = source.getBlockId(tilePos.north(queryPos)) == this.block.id();
-                    d = source.getBlockId(tilePos.south(queryPos)) == this.block.id();
-                    l = source.getBlockId(tilePos.west(queryPos)) == this.block.id();
-                    r = source.getBlockId(tilePos.east(queryPos)) == this.block.id();
+                    u = source.getBlockType(tilePos.north(queryPos)) == this.block;
+                    d = source.getBlockType(tilePos.south(queryPos)) == this.block;
+                    l = source.getBlockType(tilePos.west(queryPos)) == this.block;
+                    r = source.getBlockType(tilePos.east(queryPos)) == this.block;
                     break;
             }
             return this.coordinates[(u ? UP : 0) | (d ? DOWN : 0) | (l ? LEFT : 0) | (r ? RIGHT : 0)];
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
index e0ba0e1f2..c0b1680e4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLayer.java
@@ -24,7 +24,7 @@ public class BlockModelLayer<T extends BlockLogic> extends BlockModelStandard<T>
 
     @Override
     public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePos tilePos, @NotNull Side side, int meta) {
-        if (!side.isVertical() && source.getBlockId(tilePos) == this.block.id() && source.getBlockData(tilePos) == meta) {
+        if (!side.isVertical() && source.getBlockType(tilePos) == this.block && source.getBlockData(tilePos) == meta) {
             return false;
         }
         return super.shouldSideBeRendered(source, bounds, tilePos, side);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
index c82f91d7c..d76558d41 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelLeaves.java
@@ -57,7 +57,7 @@ public class BlockModelLeaves<T extends BlockLogic> extends BlockModelStandard<T
 
     @Override
     public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
-        if (!BlockModelGenericLeaves.fancyGraphics && source.getBlockId(tilePos) == this.block.id()) {
+        if (!BlockModelGenericLeaves.fancyGraphics && source.getBlockType(tilePos) == this.block) {
             return false;
         } else {
             return super.shouldSideBeRendered(source, bounds, tilePos, side);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
index c7202598d..b227d6627 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
@@ -18,7 +18,7 @@ public class BlockModelTransparent<T extends BlockLogic> extends BlockModelStand
 
     @Override
     public boolean shouldSideBeRendered(@NotNull WorldSource source, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, @NotNull Side side) {
-        if (!this.renderInside && source.getBlockId(tilePos) == this.block.id()) {
+        if (!this.renderInside && source.getBlockType(tilePos) == this.block) {
             return false;
         } else {
             return super.shouldSideBeRendered(source, bounds, tilePos, side);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index eaeb793e3..ef1b1e6fb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -3,7 +3,6 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.LightingCache;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -20,7 +19,7 @@ import net.minecraft.core.world.WorldSource;
 import static net.minecraft.client.render.block.model.BlockModel.FULL_CUBE_THRESHOLD;
 
 public final class RenderBlocks {
-    public final Minecraft mc;
+    public final @NotNull Minecraft mc;
     public IconCoordinate overrideBlockTexture;
     public boolean flipTexture;
     public boolean renderAllFaces;
@@ -97,14 +96,7 @@ public final class RenderBlocks {
 
     public float getBlockBrightness(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         if (this.mc.fullbright) return 1.0f;
-        int id = worldSource.getBlockId(tilePos);
-        Block<?> block = worldSource.getBlock(tilePos);
-        if (block != null) {
-
-            return block.getBrightness(worldSource, tilePos);
-        }
-
-        return worldSource.getBrightness(tilePos, Blocks.lightEmission[id]);
+        return worldSource.getBlockType(tilePos).getBrightness(worldSource, tilePos);
     }
 
     @Deprecated
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
index b5edb73fa..8040e6dd7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGeneric.java
@@ -93,7 +93,7 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
         if (direction != null) {
             TilePos shifted = blockPos.add(direction, new TilePos());
             if (this.forceCullSelf) {
-                return worldSource.getBlock(shifted) == this.block || worldSource.isBlockOpaqueCube(shifted);
+                return worldSource.getBlockType(shifted) == this.block || worldSource.isBlockOpaqueCube(shifted);
             } else {
                 return worldSource.isBlockOpaqueCube(shifted);
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceThin.java
index 3ad86b001..5ed90d3df 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFenceThin.java
@@ -4,7 +4,6 @@ import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLogicFence;
 import net.minecraft.core.block.BlockLogicFenceThin;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
@@ -38,7 +37,7 @@ public class BlockModelGenericFenceThin<T extends BlockLogicFenceThin> extends B
         boolean west = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.WEST);
         boolean east = this.block.getLogic().canConnectTo(worldSource, tilePos, Side.EAST);
 
-        Block<?> blockAbove = worldSource.getBlock(tilePos.up(queryPos));
+        Block<?> blockAbove = worldSource.getBlockType(tilePos.up(queryPos));
         boolean upNorth = blockAbove == this.block && this.block.getLogic().canConnectTo(worldSource, tilePos.up(queryPos), Side.NORTH);
         boolean upSouth = blockAbove == this.block && this.block.getLogic().canConnectTo(worldSource, tilePos.up(queryPos), Side.SOUTH);
         boolean upWest = blockAbove == this.block && this.block.getLogic().canConnectTo(worldSource, tilePos.up(queryPos), Side.WEST);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFurnace.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFurnace.java
index 471d6f532..56031bde0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericFurnace.java
@@ -1,13 +1,18 @@
 package net.minecraft.client.render.block.model.generic;
 
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
 import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.models.block.StaticBlockModel;
 
 public class BlockModelGenericFurnace<T extends BlockLogic> extends BlockModelGeneric<T> {
@@ -18,6 +23,32 @@ public class BlockModelGenericFurnace<T extends BlockLogic> extends BlockModelGe
         this.filled = BlockModelDispatcher.loadDataModel(baseKey + "_filled").asModel();
     }
 
+    @Override
+    public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
+        Direction direction = BlockLogicRotatable.getDirectionFromMeta(worldSource.getBlockData(tilePos));
+        switch (direction) {
+            case UP -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 1, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case DOWN -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, -1, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case NORTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 0, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case WEST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 1, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case EAST -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 3, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+            case SOUTH -> {
+                return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+            }
+        }
+        return getModel(worldSource, tilePos).renderAttached(this, tessellator, worldSource, tilePos, 0, 2, 0, 0, 0, 0, false, cullFaces, overrideTexture);
+    }
+
     @Override
     public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
         if (source.getTileEntity(tilePosc) instanceof Container container) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericGrass.java
new file mode 100644
index 000000000..2426570f9
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericGrass.java
@@ -0,0 +1,27 @@
+package net.minecraft.client.render.block.model.generic;
+
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.useless.dragonfly.models.block.StaticBlockModel;
+
+public class BlockModelGenericGrass<T extends BlockLogic> extends BlockModelGeneric<T> {
+    public final @NotNull StaticBlockModel snowy;
+    public BlockModelGenericGrass(@NotNull Block<T> block) {
+        super(block, BlockModelDispatcher.loadDataModel("minecraft:block/grass"));
+        this.snowy = BlockModelDispatcher.loadDataModel("minecraft:block/grass_snowy").asModel();
+    }
+
+    @Override
+    public @NotNull StaticBlockModel getModel(@NotNull WorldSource source, @NotNull TilePosc tilePosc) {
+        if (source.getBlockType(tilePosc.up(new TilePos())) == Blocks.LAYER_SNOW) {
+            return this.snowy;
+        }
+        return super.getModel(source, tilePosc);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java
index 4d3887740..63b4982dd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeaves.java
@@ -35,7 +35,7 @@ public class BlockModelGenericLeaves<T extends BlockLogic> extends BlockModelGen
         }
         if (direction != null) {
             TilePos shifted = blockPos.add(direction, new TilePos());
-            return worldSource.getBlock(shifted) == this.block || worldSource.isBlockOpaqueCube(shifted);
+            return worldSource.getBlockType(shifted) == this.block || worldSource.isBlockOpaqueCube(shifted);
         }
         return false;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
index 38258c7fd..86d6f3407 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericRope.java
@@ -27,7 +27,7 @@ public class BlockModelGenericRope<T extends BlockLogic> extends BlockModelGener
 
     @Override
     public boolean renderAttached(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos, boolean cullFaces, @Nullable IconCoordinate overrideTexture) {
-        Block<?> below = worldSource.getBlock(tilePos.down(new TilePos()));
+        Block<?> below = worldSource.getBlockType(tilePos.down(new TilePos()));
         boolean hasFloor = below != null && below.canPlaceOnSurface();
         boolean hasBlockNegX = canConnect(worldSource, tilePos, Direction.WEST);
         boolean hasBlockPosX = canConnect(worldSource, tilePos, Direction.EAST);
@@ -74,7 +74,7 @@ public class BlockModelGenericRope<T extends BlockLogic> extends BlockModelGener
 
     private boolean canConnect(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos, @NotNull Direction direction) {
         TilePos shiftedPos = tilePos.add(direction, new TilePos());
-        Block<?> _block = worldSource.getBlock(shiftedPos);
+        Block<?> _block = worldSource.getBlockType(shiftedPos);
         if (direction == Direction.DOWN) { // TODO replace with a proper system for querying what block another block is "attached" to
             if (Block.hasLogicClass(_block, BlockLogicLanternFirefly.class) && (worldSource.getBlockData(shiftedPos) & 0b1) != 0) {
                 return true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java b/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
index 983ff11c6..a22e3fd2d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/CameraUtil.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.camera;
 
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.phys.HitResult;
@@ -11,6 +12,8 @@ import org.jetbrains.annotations.Nullable;
 import org.joml.Vector3d;
 import org.joml.Vector3dc;
 
+import java.util.Objects;
+
 public abstract class CameraUtil {
     public static @Nullable HitResult traceRay(@NotNull ICamera camera, @NotNull World world, double distance, float partialTick) {
         Vector3dc pos = camera.getPosition(partialTick);
@@ -22,8 +25,8 @@ public abstract class CameraUtil {
     public static boolean isUnderLiquid(@NotNull ICamera camera, @NotNull World world, @NotNull Material material, float partialTick) {
         double cameraY = camera.getY(partialTick);
         TilePos tilePos = camera.getTilePos(partialTick);
-        int id = world.getBlockId(tilePos);
-        if (id != 0 && Blocks.blocksList[id].getMaterial() == material) {
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+        if (block.getMaterial() == material) {
             float fluidHeight = BlockLogicFluid.getHeight(world.getBlockData(tilePos)) - 0.2F;
             float waterSurface = (float) (tilePos.y + 1) - fluidHeight;
             return cameraY < (double) waterSurface;
diff --git a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
index 4bdbe814a..5766e384f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
+++ b/game/client/src/main/java/net/minecraft/client/render/colorizer/Colorizers.java
@@ -9,6 +9,7 @@ import java.util.List;
 import javax.imageio.ImageIO;
 
 import com.mojang.logging.LogUtils;
+import it.unimi.dsi.fastutil.objects.ObjectArrayList;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.texturepack.TexturePack;
 import net.minecraft.core.Global;
@@ -18,13 +19,14 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.season.SeasonManagerCycle;
 import net.minecraft.core.world.season.Seasons;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 public class Colorizers {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	public static Minecraft mc;
 	
-	private static List<Colorizer> allColorizers = null;
+	private static final @NotNull List<Colorizer> allColorizers = new ObjectArrayList<>();
 
 	public static Colorizer grass;
 	public static Colorizer water;
@@ -48,7 +50,7 @@ public class Colorizers {
 	
 	private static float fadeDuration = 1.0f;
 	
-	public static void init(Minecraft minecraft) {
+	public static void init(@NotNull Minecraft minecraft) {
 		mc = minecraft;
 		
 		registerColorizers();
@@ -56,19 +58,21 @@ public class Colorizers {
 	
 	public static void reload() {
 		List<Season> seasons = Seasons.getAllSeasons();
-		
-		for(int i=0; i < allColorizers.size(); i++) {
-			Colorizer colorizer = allColorizers.get(i);
+		registerColorizers();
+
+		for (Colorizer colorizer : allColorizers) {
 			colorizer.setup(mc, seasons);
 			TexturePack texturePack = colorizer.getTexturePack();
 			if(texturePack != null) {
-                LOGGER.info("Using {} color from asset pack {}", colorizer.name, texturePack.fileName);
+				LOGGER.info("Using {} color from asset pack {}", colorizer.name, texturePack.fileName);
 			}
 		}
+
+		update(true);
 	}
 	
 	public static void registerColorizers() {
-		allColorizers = new ArrayList<>();
+		allColorizers.clear();
 		
 		grass = add(new Colorizer("grass"));
 		water = add(new Colorizer("water"));
@@ -115,10 +119,6 @@ public class Colorizers {
 			return;
 		}
 		
-		if(currentDimension != lastDimension) {
-			reload();
-		}
-		
 		lastDimension = currentDimension;
 		lastSeason = currentSeason;
 		lastSeasonProgress = seasonProgress;
@@ -243,9 +243,8 @@ public class Colorizers {
 	}
 	
 	public static float getSeasonProgress(World world) {
-		if(world.seasonManager instanceof SeasonManagerCycle) {
-			SeasonManagerCycle seasonManager = (SeasonManagerCycle) world.seasonManager;
-			Season currentSeason = seasonManager.getCurrentSeason();
+		if(world.seasonManager instanceof SeasonManagerCycle seasonManager) {
+            Season currentSeason = seasonManager.getCurrentSeason();
 			
 			int dayInSeason = seasonManager.getDayInSeason();
 			int dayLengthTicks = Global.DAY_LENGTH_TICKS;
